// Copyright (C) 1999 Fredrik Ohrstrom /////////////////////////////////////
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Library General Public
//    License as published by the Free Software Foundation; either
//    version 2 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Library General Public License for more details.
//
//    You should have received a copy of the GNU Library General Public
//    License along with this library; if not, write to the Free
//    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
//    02111-1307, USA
//
// File     : matrix.hh
// Contents : An matrix class.
//            These objects are not distributable.
// Classes  : matrix<> matrix<>::iter

#ifndef _matrix_H
#define _matrix_H

#include "ref.hh"

class OutOfRange
{
};

template<class T>
class matrix
{
        public:

        matrix (int width=1, int height=1)
        {
                data_ = new matrixData (width,height);
        }
        
        void setSize (int width, int height)
        {
                data_ = new matrixData (width,height);
        }
        
        T get (int x, int y) 
        {
                return data_->matrix_[x+(y*data_->width_)];
        }

        void set (int x, int y, T t) 
        {
                data_->matrix_[x+(y*data_->width_)] = t;
        }
        
        struct matrixData;
        
        private:
        
        struct matrixData : public ref
        {
                matrixData (int w, int h) 
                { 
                        matrix_ = new T[w*h];
                        width_ = w;
                        height_ = h;
                }
                ~matrixData ()
                {
                        delete [] matrix_;
                }
                int width_, height_;
                T *matrix_;
        };
        
        lptr<matrixData> data_;
};

#endif

