// Copyright (C) 1999 Fredrik Ohrstrom
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//    USA.

#include<unistd.h>
#include<map>

#include"Window_X_Implementations.hh"
#include"Interaction_X_Implementations.hh"

using namespace Window_X_Implementations;
using namespace Interaction_X_Implementations;

InteractionXFactory_ptr ui = interaction_x_factory;
WindowXFactory_ptr gfx = window_x_factory;

class UITest : public Component_i
{
        public:

        Group_ptr uigroup;
        AtomicMessage_ptr welcome;
        TextChoice_ptr text;
        
        UITest ()
                        : Component_i (NULL, Latin1("uitest")),
                          ClassType (Latin1("UITest"))
        {
                uigroup = ui->newXRootGroup (this, Latin1("uigroup"));
                welcome = ui->newAtomicMessage (this, Latin1("welcome"), uigroup);
                text = ui->newTextChoice (this, Latin1("text"), uigroup);
                uigroup->activate ();
        }
};

int main (int argc, char **argv)
{
        useResourceFile ("uitest.res");
        UITest t;

        for (;;);
}










